"{ Package: 'exept:regression' }"

"{ NameSpace: RegressionTests }"

Object subclass:#CompilerTest
	instanceVariableNames:'value'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-Regression'
!


!CompilerTest methodsFor:'helpers'!

value:something
    value := something
! !

!CompilerTest methodsFor:'test - inlined'!

test_even:arg
    ^ arg even

    "
     self new test_even:nil               
     self new test_even:123
     self new test_even:122
     self new test_even:(100 factorial)
    "
!

test_isInteger:arg
    ^ arg isInteger

    "
     self new test_isInteger:nil               
     self new test_isInteger:123
     self new test_isInteger:(100 factorial)
    "
!

test_isNotInteger:arg
    ^ arg isInteger not

    "
     self new test_isNotInteger:nil               
     self new test_isNotInteger:123
     self new test_isNotInteger:(100 factorial)
    "
!

test_odd:arg
    ^ arg odd

    "
     self new test_odd:nil               
     self new test_odd:123   
     self new test_odd:122     
     self new test_odd:(100 factorial)  
    "
!

test_size
    ^ value size

    "
     (self new value:(Array new:2)) test_size
     (self new value:(OrderedCollection new:2)) test_size
    "
! !

!CompilerTest methodsFor:'tests - booleans'!

testAnd:arg1 _:arg2
    ^ arg1 & arg2

    "
     self new testAnd:true _:true.      
     self new testAnd:true _:false.     
     self new testAnd:false _:true.     
     self new testAnd:false _:false.    
     self new testAnd:false _:nil.      
     self new testAnd:true _:nil. 
     self new testAnd:nil _:false.
     self new testAnd:nil _:true.
     self new testAnd:1234 _:true.
     self new testAnd:1234 _:false.
     self new testAnd:true _:1234.   
     self new testAnd:false _:1234.  
    "
!

testNot1:arg
    ^ arg not

    "
     self new testNot1:true.   
     self new testNot1:false.
     self new testNot1:1234.
    "
!

testNot2:arg1 _:arg2
    ^ arg1 not & arg2 not

    "
     self new testNot2:true  _:true.   
     self new testNot2:false _:true.
     self new testNot2:true  _:false.
     self new testNot2:false _:false.

     self new testNot2:false _:1234.
     self new testNot2:true  _:1234.
     self new testNot2:1234  _:true.
     self new testNot2:1234  _:false.
     self new testNot2:1234  _:2345.
    "
!

testOr:arg1 _:arg2
    ^ arg1 | arg2

    "
     self new testOr:true _:true.      
     self new testOr:true _:false.     
     self new testOr:false _:true.     
     self new testOr:false _:false.    
     self new testOr:false _:nil.      
     self new testOr:true _:nil. 
     self new testOr:nil _:false.
     self new testOr:nil _:true.
     self new testOr:1234 _:true.
     self new testOr:1234 _:false.
     self new testOr:true _:1234.   
     self new testOr:false _:1234.  
    "
! !

!CompilerTest methodsFor:'tests - conditions'!

testIf1:val
    |x|

    x := #foo.
    x := (val == #CursorRight or:[val == #CursorDown]) ifTrue:[1].
    ^ x

    "
     self new testIf1:#CursorRight
     self new testIf1:#CursorDown
     self new testIf1:#Foo             
     self new testIf1:#CursorUp        
     self new testIf1:nil              
     self new testIf1:1             
    "
!

testIf2:val
    |x|

    x := #foo.
    x := (val == #CursorRight or:[val == #CursorDown]) ifTrue:1.
    ^ x

    "
     self new testIf2:#CursorRight
     self new testIf2:#CursorDown
     self new testIf2:#Foo          
     self new testIf2:#CursorUp     
     self new testIf2:nil           
     self new testIf2:1             
    "
!

testIf3:val
    |x|

    x := #foo.
    x := (val isInteger) ifTrue:1.
    ^ x

    "
     self new testIf3:#CursorRight
     self new testIf3:#CursorDown
     self new testIf3:#Foo          
     self new testIf3:#CursorUp     
     self new testIf3:nil           
     self new testIf3:1             
    "
!

testIf4:val
    ^ val isNil

    "
     self new testIf4:#CursorRight 
     self new testIf4:1             
     self new testIf4:nil             
    "
!

testIf4:val1 with:val2
    ^ (val1 == nil and:[val2 == nil])

    "
     self new testIf4:#CursorRight with:#CursorDown  
     self new testIf4:#CursorRight with:nil          
     self new testIf4:nil with:#CursorDown
     self new testIf4:nil with:nil
    "
!

testIf5:val
    ^ val isNil ifTrue:[1]

    "
     self new testIf5:#CursorRight 
     self new testIf5:1             
     self new testIf5:nil             
    "
!

testIf5:val1 with:val2
    ^ (val1 isNil and:[val2 isNil])

    "
     self new testIf5:#CursorRight with:#CursorDown  
     self new testIf5:#CursorRight with:nil          
     self new testIf5:nil with:#CursorDown
     self new testIf5:nil with:nil
    "
!

testIf6:val
    ^ val isNil ifTrue:1

    "
     self new testIf6:#CursorRight  
     self new testIf6:1             
     self new testIf6:nil             
    "
!

testIf6b:val
    val isNil ifTrue:1

    "
     self new testIf6b:#CursorRight  
     self new testIf6b:1             
     self new testIf6b:nil             
    "
!

testIf6c:val
    val isNil ifTrue:[1]

    "
     self new testIf6c:#CursorRight  
     self new testIf6c:1             
     self new testIf6c:nil             
    "
!

testIf6d:val
    ^ val isNil ifTrue:val

    "
     self new testIf6d:#CursorRight  
     self new testIf6d:1             
     self new testIf6d:nil             
    "
!

testIf6e:val
    ^ val isNil ifFalse:val

    "
     self new testIf6e:['hello']    
     self new testIf6e:('hello' asValue)  
     self new testIf6e:#CursorRight  
     self new testIf6e:1             
     self new testIf6e:nil             
    "
!

testIf7:val
    ^ val ? 1

    "
     self new testIf7:#CursorRight  
     self new testIf7:1             
     self new testIf7:nil             
    "
!

testIfElse1:val
    |x|

    x := (val == #CursorRight or:[val == #CursorDown]) ifTrue:[1] ifFalse:[-1].
    ^ x

    "
     self new testIfElse1:#CursorRight
     self new testIfElse1:#CursorDown
     self new testIfElse1:#Foo             
     self new testIfElse1:#CursorUp        
     self new testIfElse1:nil              
     self new testIfElse1:1             
    "
!

testIfElse2:val
    |x|

    x := (val == #CursorRight or:[val == #CursorDown]) ifTrue:1 ifFalse:-1.
    ^ x

    "
     self new testIfElse2:#CursorRight
     self new testIfElse2:#CursorDown
     self new testIfElse2:#Foo          
     self new testIfElse2:#CursorUp     
     self new testIfElse2:nil           
     self new testIfElse2:1             
    "
!

testIfElse3:val
    |x|

    x := (val == #CursorRight or:[val isInteger]) ifTrue:1 ifFalse:-1.
    ^ x

    "
     self new testIfElse3:#CursorRight 
     self new testIfElse3:#CursorDown  
     self new testIfElse3:#Foo          
     self new testIfElse3:#CursorUp     
     self new testIfElse3:nil           
     self new testIfElse3:1             
    "
!

testIfElse4:val
    |x|

    x := #foo.
    x := (val isInteger) ifTrue:1 ifFalse:-1.
    ^ x

    "
     self new testIfElse4:#CursorRight  
     self new testIfElse4:#CursorDown   
     self new testIfElse4:#Foo          
     self new testIfElse4:#CursorUp     
     self new testIfElse4:nil           
     self new testIfElse4:1             
    "
!

testIfElse5:val
    |x|

    x := #foo.
    x := val ifNil:1 ifNotNil:-1.
    ^ x

    "
     self new testIfElse5:#CursorUp     
     self new testIfElse5:nil           
     self new testIfElse5:1             
    "
!

testIfElse6:val
    |x|

    x := #foo.
    x := val ifNil:[1] ifNotNil:[-1].
    ^ x

    "
     self new testIfElse6:#CursorUp     
     self new testIfElse6:nil           
     self new testIfElse6:1             
    "
!

testIfElse7:val with:val1 with:val2
    |x|

    x := #foo.
    x := val ifNil:val1 ifNotNil:val2.
    ^ x

    "
     self new testIfElse7:#CursorUp with:1 with:2    
     self new testIfElse7:nil       with:1 with:2        
     self new testIfElse7:1         with:1 with:2        
    "
! !

!CompilerTest methodsFor:'tests - constant folding'!

testFloat_pi
    ^ Float pi
!

testFloat_unity
    ^ Float unity
!

testFloat_zero
    ^ Float zero
!

testSmalltalk_if_else_isSmalltalkX
    Smalltalk isSmalltalkX ifTrue:[
	^ 'yes'
    ] ifFalse:[
	^ 'no'
    ]
!

testSmalltalk_if_else_isVisualWorks
    Smalltalk isVisualWorks ifTrue:[
	^ 'yes'
    ] ifFalse:[
	^ 'no'
    ]
!

testSmalltalk_if_isSmalltalkX
    Smalltalk isSmalltalkX ifTrue:[
	^ 'yes'
    ].
    ^ 'no'
!

testSmalltalk_if_isSqueak
    Smalltalk isSqueak ifTrue:[
	^ 'yes'
    ].
    ^ 'no'
!

testSmalltalk_if_isVisualWorks
    Smalltalk isVisualWorks ifTrue:[
	^ 'yes'
    ].
    ^ 'no'
!

testSmalltalk_isSmalltalkX
    ^ Smalltalk isSmalltalkX
!

testSmalltalk_isSqueak
    ^ Smalltalk isSqueak
!

testSmalltalk_isVisualAge
    ^ Smalltalk isVisualAge
!

testSmalltalk_isVisualWorks
    ^ Smalltalk isVisualWorks
!

testUnaryFolding
    self testFloat_pi ~= (Float perform:#pi) ifTrue:[self halt].
    self testFloat_unity ~= (Float perform:#unity) ifTrue:[self halt].
    self testFloat_zero ~= (Float perform:#zero) ifTrue:[self halt].

    self testSmalltalk_isSmalltalkX ~= (Smalltalk perform:#isSmalltalkX) ifTrue:[self halt].
    self testSmalltalk_isSqueak ~= (Smalltalk perform:#isSqueak) ifTrue:[self halt].
    self testSmalltalk_isVisualWorks ~= (Smalltalk perform:#isVisualWorks) ifTrue:[self halt].
    self testSmalltalk_isVisualAge ~= (Smalltalk perform:#isVisualAge) ifTrue:[self halt].

    "
     self basicNew testUnaryFolding
    "
! !

!CompilerTest class methodsFor:'documentation'!

version
    ^ '$Header$'
! !
